#!/bin/bash

############################################################################
#    Copyright (C) 2008-2009 by Jaroslaw Zachwieja <grok@zyxxyz.eu>        #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 3 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program.  If not, see <http://www.gnu.org/licenses/>. #
############################################################################

if (test -s ./autoripper.conf)
then
	. ./autoripper.conf
	echo "Found config file './autoripper.conf', loading."
elif (test -s ~/.autoripper.conf)
then
	. ~/.autoripper.conf
	echo "Found config file '~/.autoripper.conf', loading."
elif (test -s /etc/autoripper.conf)
then
	. /etc/autoripper.conf
	echo "Found config file '/etc/autoripper.conf', loading."
else
	echo "No config file found, using defaults."
fi

DEFAULT_ISO_STORAGE="./dvdrips"
DEFAULT_DVD_RIPPING_DEVICE="/dev/sr0"

if (test -z $ISO_STORAGE)
then
	ISO_STORAGE="$DEFAULT_ISO_STORAGE"
fi

if (test -z $DVD_RIPPING_DEVICE)
then
	DVD_RIPPING_DEVICE=$DEFAULT_DVD_RIPPING_DEVICE
fi

/usr/bin/mplayer dvd:// -dvd-device $DVD_RIPPING_DEVICE -ss 1 -endpos 1 -identify -really-quiet -vo null -ao null
TITLE="`lsdvd $DVD_RIPPING_DEVICE | grep 'Disc Title:' | awk '{print $3}'`"
echo "$TITLE"

if [ -a "${ISO_STORAGE}/${TITLE}.iso" ]
then
        TITLE=""
fi
if [ "$TITLE" != "" ]
then
        echo "Found DVD: $TITLE. Ripping..."
        ionice -c 3 nice -n 10 dd if=$DVD_RIPPING_DEVICE of=${ISO_STORAGE}/${TITLE}.iso.partial bs=2k  || rm -f ${ISO_STORAGE}/${TITLE}.iso.partial
        mv -f ${ISO_STORAGE}/${TITLE}.iso.partial ${ISO_STORAGE}/${TITLE}.iso
        echo "Ripping of $TITLE finished."
fi

sleep 5

eject ${DEV}
